/***
 * Juliac
 * Copyright (C) 2012-2013a, Univ. Lille 1
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: fractal@ow2.org
 *
 * Author: Lionel Seinturier
 */

package org.objectweb.fractal.juliac.opt.ultracomp;

import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.juliac.desc.MembraneDesc;

/**
 * Basic implementation of the interceptor component type generator.
 * 
 * @author Lionel Seinturier <Lionel.Seinturier@univ-lille1.fr>
 * @since 2.5
 */
public class InterceptorComponentTypeGeneratorImpl
implements InterceptorComponentTypeGeneratorItf {

	private InterfaceType it;
	
	public InterceptorComponentTypeGeneratorImpl( InterfaceType it ) {
		this.it = it;
	}
	
	public InterfaceType[]
		match( InterfaceType it, MembraneDesc<?> membraneDesc ) {

		if( it.isFcClientItf() ) {
            return null;   // Skip client interfaces
        }
        String name = it.getFcItfName();
        if( name.endsWith("-controller") || name.equals("component") ) {
            return null;   // Skip control interfaces
        }
        
        return new InterfaceType[]{this.it};
	}
}
